var giImage_Index = 0;
var gsImage_URL = "";
var gsImage_Title = "";
var gsImage_Link = "";
var gsImageDescription = "";

var gsGallery_URL = Array();

function getXMLField(sData, sFieldTag, iStartIndex)
{

	iStart = sData.indexOf("<"+sFieldTag+">",iStartIndex)+sFieldTag.length+2;
	iEnd   = sData.indexOf("</"+sFieldTag+">",iStartIndex);
	if ((iStart < 0) || (iEnd < 0)) {
		return "";
	} else {
		return sData.substring(iStart, iEnd);
	}
}

function getText(sData, sStartMarker, sEndMarker)
{
	iStart = sData.toLowerCase().indexOf(sStartMarker.toLowerCase());
	iEnd   = sData.toLowerCase().indexOf(sEndMarker.toLowerCase(),iStart+sStartMarker.length);
	if ((iStart < 0)||(iEnd < 0)||(iStart >= iEnd)) {
		return "";
	} else {
		return sData.substring(iStart+sStartMarker.length, iEnd);
	}
}

function Trim(sText)
{
	return sText.replace(/^\s+/g, "").replace(/\s+$/g, "");;
}

function initWidget()
{
	var objURL = new URL();
	var re = /image_feature[^"]+(?:html)/g;
	var tokens;

//	Fetch and parse gallery pages
	for (i = 0; i < 4; i++) {
		if (i == 0) {
			objURL.location = "http://www.nasa.gov/multimedia/imagegallery/";
		} else {
			objURL.clear;
			objURL.location = "http://www.nasa.gov/multimedia/imagegallery/archives"+i+".html";
		}
		objURL.fetch();
		sXML = objURL.result;
		while ((tokens = re.exec(sXML)) != null){
			gsGallery_URL[gsGallery_URL.length] = tokens;
		}
	}

//	Update refresh timer
	refreshtimer.interval = preferences.refreshrate.value;

}

function loadImage(iIndex)
{

//	Make sure index is valid
	if (iIndex < 0)
		iIndex = 0;

	if (iIndex > gsGallery_URL.length)
		iIndex = gsGallery_URL.length;
	
	giImageIndex = iIndex;

//	Fetch image gallery page and extract image info
	var objURL = new URL();
	objURL.location = "http://www.nasa.gov/multimedia/imagegallery/" + gsGallery_URL[iIndex];
	objURL.fetch();
	sHTML = objURL.result;
	sHRef = getText(sHTML, "<!-- Main Image starts -->", "<!-- Main Image ends -->");
	giImage_Index = iIndex;
	gsImage_Title = getText(sHRef, "ALT=\"", "\"");
	gsImage_URL   = "http://www.nasa.gov"+getText(sHRef, "SRC=\"", "\"");
	gsImage_Link  = "http://www.nasa.gov/multimedia/imagegallery/"+gsGallery_URL[iIndex];

//	Fetch image gallery page and save to cache
	objURL.clear;
	objURL.outputFile = "resources/cache/image.jpg";
	objURL.location = gsImage_URL;
	objURL.fetch();

}

function drawImage()
{

//	Display image from cache
	photo.src = "";
	photo.src = "resources/cache/image.jpg";

//	Source width and height
	wsrc = photo.srcWidth;
	hsrc = photo.srcHeight;

//	Destination width and height (check for aspect ratio preference)
	w = Math.round(preferences.imagewidth.value);
	if (preferences.lockaspectratio.value==0){	
		h = Math.round(w * hsrc/wsrc);
	}else{
		h = Math.round(w * 387/516);
	}

//	Draw frame
	window_main.width  = w + 20;
	window_main.height = h + 20;
	photo.width  = w;
	photo.height = h;
	for (i = 1; i < 4; i++) {
		eval("frame_"+i+"2.width=w;");
		eval("frame_2"+i+".height=h;");
		eval("frame_"+i+"3.hOffset=w+10;");
		eval("frame_3"+i+".vOffset=h+10;");
	}
	status.hOffset=10+w/2;

//	Colorize frame
	gsFrameColor = preferences.framecolor.value;
	for (i = 1; i < 4; i++) {
		for (j = 1; j < 4; j++) {
			eval("frame_"+i+""+j+".colorize=gsFrameColor;");
		}
	}

//	Display image info
	if (preferences.showtooltip.value==1){
		photo.tooltip = gsImage_Title;
	} else {
		photo.tooltip = "";
	}
	photo.reload();
	
}

function updatePreferences()
{

	drawImage();

	if (refreshtimer.interval != preferences.refreshrate.value){
		refreshtimer.ticking = 0;
		refreshtimer.interval = preferences.refreshrate.value;
		refreshtimer.ticking = 1;
	}

}

function refreshDisplay()
{
	refreshtimer.ticking = 0;
	n = 1+Math.round(Math.random() * (gsGallery_URL.length-2));
	status.data="Loading Image "+n+" of "+(gsGallery_URL.length-1);
	updateNow();
	suppressUpdates();	
	loadImage(n);
	drawImage();
	status.data="";
	resumeUpdates();
	refreshtimer.ticking = 1;
}

function viewImageInfo()
{
	if (gsImage_Link != "") {
		openURL(gsImage_Link);	
	}
}

suppressUpdates();
initWidget();
loadImage(0);
drawImage();
status.data="";
resumeUpdates();

